DEFINT A-Z
DIM word1Array$(1 TO 1000)
DIM word2Array$(1 TO 1000)
OPEN "PAIRS.TXT" FOR OUTPUT AS 1
OPEN "REVPAIRS.TXT" FOR OUTPUT AS 2
OPEN "SOURCE.TXT" FOR OUTPUT AS 3
' Get 1000 pairs with 1-30 chars each.
RANDOMIZE TIMER
FOR i = 1 TO 1000
    length1 = INT(RND * 30) + 1
    length2 = INT(RND * 30) + 1
    word1$ = ""
    FOR j = 1 TO length1
        SELECT CASE RND
            CASE IS > .7
                ' 30% upper case chars.
                word1$ = word1$ + CHR$(INT(RND * 26) + 65)
            CASE IS > .1
                ' 60% lower case chars.
                word1$ = word1$ + CHR$(INT(RND * 26) + 97)
            CASE IS > .05
                ' 5% decimal digits, but not for first char.
                IF j = 1 THEN
                    word1$ = word1$ + " "
                ELSE
                    word1$ = word1$ + CHR$(INT(RND * 10) + 48)
                END IF
            CASE ELSE
                ' 5% underscore chars.
                word1$ = word1$ + "_"
        END SELECT
    NEXT
    word2$ = ""
    FOR j = 1 TO length2
        SELECT CASE RND
            CASE IS > .7
                word2$ = word2$ + CHR$(INT(RND * 26) + 65)
            CASE IS > .1
                word2$ = word2$ + CHR$(INT(RND * 26) + 97)
            CASE IS > .05
                IF j = 1 THEN
                    word2$ = word2$ + " "
                ELSE
                    word2$ = word2$ + CHR$(INT(RND * 10) + 48)
                END IF
            CASE ELSE
                word2$ = word2$ + "_"
        END SELECT
    NEXT
    ' Use mix of separators.
    SELECT CASE RND
        CASE IS > .66
            sep$ = " = "
        CASE IS > .33
            sep$ = "="
        CASE ELSE
            sep$ = " "
    END SELECT
    ' Do not add to files if either word is
    ' duplicate, or null, or spaces only.
    word1trim$ = LTRIM$(RTRIM$(word1$))
    word2trim$ = LTRIM$(RTRIM$(word2$))
    FOR j = ptr TO 1 STEP -1
        IF LTRIM$(RTRIM$(word1Array$(j))) = word1trim$ THEN EXIT FOR
    NEXT
    IF j = 0 THEN
        ' Word1 was not duplicate.
        FOR j = ptr TO 1 STEP -1
            IF LTRIM$(RTRIM$(word2Array$(j))) = word2trim$ THEN EXIT FOR
        NEXT
        IF j = 0 THEN
            ' Word2 was not duplicate.
            IF word1trim$ <> "" AND word2trim$ <> "" THEN
                ptr = ptr + 1
                word1Array$(ptr) = word1$
                word2Array$(ptr) = word2$
                ' Store pair and reverse pair to files.
                PRINT #1, word1$; sep$; word2$
                PRINT #2, word2$; sep$; word1$
                ' Store first word to source file.
                PRINT #3, word1$
            END IF
        END IF
    END IF
NEXT
CLOSE
END

